# Generated by Django 3.2.25 on 2024-05-21 11:59

from django.db import migrations, models
from django.db.migrations.operations.models import ModelOptionOperation
import django.db.models.deletion


def migrate_plugins(apps, schema_editor):
    UpcomingEventsPlugin = apps.get_model("djangocms_blog_agenda.UpcomingEventsPlugin")
    UpcomingEventsPluginNew = apps.get_model(
        "djangocms_blog_agenda.UpcomingEventsPluginNew"
    )

    for plugin in UpcomingEventsPlugin.objects.all():
        UpcomingEventsPluginNew.objects.create(latestpostsplugin_ptr=plugin)


class AddModelBasesOptions(ModelOptionOperation):
    def __init__(self, name, bases):
        self.bases = bases
        super().__init__(name)

    def deconstruct(self):
        kwargs = {
            "name": self.name,
        }
        return (self.__class__.__qualname__, [], kwargs)

    def state_forwards(self, app_label, state):
        model_state = state.models[app_label, self.name_lower]
        model_state.bases = self.bases
        state.reload_model(app_label, self.name_lower, delay=True)

    def database_forwards(self, app_label, schema_editor, from_state, to_state):
        pass

    def database_backwards(self, app_label, schema_editor, from_state, to_state):
        pass

    def describe(self):
        return "Add bases to the model %s" % self.name

    @property
    def migration_name_fragment(self):
        return "add_%s_bases" % self.name_lower


class Migration(migrations.Migration):
    dependencies = [
        ("djangocms_blog", "0042_alter_authorentriesplugin_cmsplugin_ptr_and_more"),
        ("djangocms_blog_agenda", "0004_pasteventsplugin"),
    ]

    operations = [
        migrations.CreateModel(
            name="UpcomingEventsPluginNew",
            fields=[
                (
                    "latestpostsplugin_ptr",
                    models.OneToOneField(
                        auto_created=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        parent_link=True,
                        primary_key=True,
                        serialize=False,
                        to="djangocms_blog.latestpostsplugin",
                    ),
                ),
                (
                    "show_until_event_end",
                    models.BooleanField(
                        default=True, verbose_name="Show events until their end date"
                    ),
                ),
            ],
            options={
                "verbose_name": "Upcoming events plugin",
                "verbose_name_plural": "Upcoming events plugins",
            },
            # bases=('djangocms_blog.latestpostsplugin',),  # We avoid making a child class to allow creating UpcomingEventsPluginNew objects without creating the inherited objects (latestpostsplugin_ptr) that already exist
        ),
        migrations.RunPython(migrate_plugins),
        migrations.DeleteModel(
            name="UpcomingEventsPlugin",
        ),
        AddModelBasesOptions(
            name="UpcomingEventsPluginNew",
            bases=("djangocms_blog.latestpostsplugin",),
        ),
        migrations.RenameModel(
            old_name="UpcomingEventsPluginNew", new_name="UpcomingEventsPlugin"
        ),
    ]
